[![Python](https://img.shields.io/pypi/pyversions/d3blocks)](https://img.shields.io/pypi/pyversions/d3blocks)
[![Pypi](https://img.shields.io/pypi/v/d3blocks)](https://pypi.org/project/d3blocks/)
[![Docs](https://img.shields.io/badge/Sphinx-Docs-blue)](https://d3blocks.github.io/d3blocks/)
[![LOC](https://sloc.xyz/github/d3blocks/d3blocks/?category=code)](https://github.com/d3blocks/d3blocks/)
[![Downloads](https://static.pepy.tech/personalized-badge/d3blocks?period=month&units=international_system&left_color=grey&right_color=brightgreen&left_text=PyPI%20downloads/month)](https://pepy.tech/project/d3blocks)
[![Downloads](https://static.pepy.tech/personalized-badge/d3blocks?period=total&units=international_system&left_color=grey&right_color=brightgreen&left_text=Downloads)](https://pepy.tech/project/d3blocks)
[![License](https://img.shields.io/badge/license-GPL3-green.svg)](https://github.com/d3blocks/d3blocks/blob/master/LICENSE)
[![Forks](https://img.shields.io/github/forks/d3blocks/d3blocks.svg)](https://github.com/d3blocks/d3blocks/network)
[![Open Issues](https://img.shields.io/github/issues/d3blocks/d3blocks.svg)](https://github.com/d3blocks/d3blocks/issues)
[![Project Status](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)
[![Medium](https://img.shields.io/badge/Medium-Blog-black)](https://d3blocks.github.io/d3blocks/pages/html/Documentation.html#medium-blog)
![GitHub Repo stars](https://img.shields.io/github/stars/d3blocks/d3blocks)
![GitHub repo size](https://img.shields.io/github/repo-size/d3blocks/d3blocks)
[![Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://d3blocks.github.io/d3blocks/pages/html/Documentation.html#colab-notebook)
[![Donate](https://img.shields.io/badge/Support%20this%20project-grey.svg?logo=github%20sponsors)](https://d3blocks.github.io/d3blocks/pages/html/Documentation.html#)

### 

<div>

<a href="https://d3blocks.github.io/d3blocks/"><img src="https://github.com/d3blocks/d3blocks/blob/main/logo.png" width="275" align="left" /></a>
``D3Blocks`` is a Python package that builds on the graphics of d3 javascript (d3js). It allows you to create the most visually attractive and useful charts with only a few lines of Python code!
The [documentation pages](https://d3blocks.github.io/d3blocks/) contains detailed information about the working of the blocks with many examples. **⭐️ Star it if you like it ⭐️**
</div>

---

<p align="center">
  <a href="https://d3blocks.github.io/d3blocks/pages/html/index.html">
  <img src="https://github.com/d3blocks/d3blocks/blob/main/docs/figs/summary.png" width="600" />
  </a>
</p>

---

### Resources and Links
- **Example Notebooks:** [Examples](https://d3blocks.github.io/d3blocks/pages/html/Documentation.html#google-colab-notebooks)
- **Blog Posts:** [Medium](https://erdogant.medium.com/)
- **Documentation:** [Website](https://d3blocks.github.io/d3blocks)
- **Bug Reports and Feature Requests:** [GitHub Issues](https://github.com/d3blocks/d3blocks/issues)


---


### Key Pipelines

| Feature | Description |
|---------|-------------|
| [**Interactive Network Visualization**](https://d3blocks.github.io/d3blocks/pages/html/d3graph.html) | Create interactive network graphs with D3graph and Elasticgraph for relationship analysis. |
| [**Data Flow Visualization**](https://d3blocks.github.io/d3blocks/pages/html/Sankey.html) | Visualize data flows and relationships using Sankey diagrams and Chord diagrams. |
| [**Temporal Data Analysis**](https://d3blocks.github.io/d3blocks/pages/html/Timeseries.html) | Analyze time-series data with interactive charts and moving bubbles for dynamic visualization. |
| [**Statistical Visualization**](https://d3blocks.github.io/d3blocks/pages/html/Scatter.html) | Create statistical plots including scatter plots, violin plots, and heatmaps. |
| [**Hierarchical Data Visualization**](https://d3blocks.github.io/d3blocks/pages/html/Tree.html) | Visualize hierarchical structures with tree diagrams, treemaps, and circle packing. |

-------------------------------------------------------------------------
### [Supported charts](https://d3blocks.github.io/d3blocks/)


|  nr |  Block                                                                             |    Function                  |    Blog                                                                                                                              |
|-----|------------------------------------------------------------------------------------|------------------------------|--------------------------------------------------------------------------------------------------------------------------------------|
|  1  | [D3graph](https://erdogant.github.io/d3graph/pages/html/index.html)                | ``` d3.d3graph() ```         | [D3graph](https://erdogant.medium.com)                                                                                               |
|  2  | [Elasticgraph](https://d3blocks.github.io/d3blocks/pages/html/elasticgraph.html)   | ``` d3.elasticgraph() ```    | [Elasticgraph](https://erdogant.medium.com)                                                                                          |
|  3  | [Sankey](https://d3blocks.github.io/d3blocks/pages/html/Sankey.html)               | ``` d3.sankey()  ```         | [Sankey](https://erdogant.medium.com)                                                                                                |
|  4  | [Movingbubbles](https://d3blocks.github.io/d3blocks/pages/html/MovingBubbles.html) | ``` d3.movingbubbles()  ```  | [Movingbubbles](https://erdogant.medium.com)    |
|  5  | [Scatter](https://d3blocks.github.io/d3blocks/pages/html/Scatter.html)             | ``` d3.scatter()  ```        | [Scatter](https://erdogant.medium.com)       |
|  6  | [Heatmap](https://d3blocks.github.io/d3blocks/pages/html/Heatmap.html)             | ``` d3.heatmap()  ```        | [Heatmap](https://erdogant.medium.com)  |
|  7  | [Chord diagram](https://d3blocks.github.io/d3blocks/pages/html/Chord.html)         | ``` d3.chord()  ```          | [D3Blocks](https://erdogant.medium.com) |
|  8  | [Timeseries](https://d3blocks.github.io/d3blocks/pages/html/Timeseries.html)       | ``` d3.timeseries()  ```     | [D3Blocks](https://erdogant.medium.com) |
|  9  | [Image slider](https://d3blocks.github.io/d3blocks/pages/html/Imageslider.html)    | ``` d3.imageslider()  ```    | [D3Blocks](https://erdogant.medium.com) |
|  10 | [Violin plot](https://d3blocks.github.io/d3blocks/pages/html/Violin.html)          | ``` d3.violin()  ```         | [D3Blocks](https://erdogant.medium.com) |
|  11 | [Particles](https://d3blocks.github.io/d3blocks/pages/html/Particles.html)         | ``` d3.particles()  ```      | [D3Blocks](https://erdogant.medium.com) |
|  12 | [Treemap](https://d3blocks.github.io/d3blocks/pages/html/Treemap.html)             | ``` d3.treemap()  ```        | [D3Blocks](https://erdogant.medium.com) |
|  13 | [Tree](https://d3blocks.github.io/d3blocks/pages/html/Tree.html)                   | ``` d3.tree()  ```           | [D3Blocks](https://erdogant.medium.com) |
|  14 | [Maps](https://d3blocks.github.io/d3blocks/pages/html/Maps.html)                   | ``` d3.maps()  ```           | [D3Blocks](https://erdogant.medium.com) |
|  15 | [Circlepacking](https://d3blocks.github.io/d3blocks/pages/html/Circlepacking.html) | ``` d3.circlepacking()  ```  | [D3Blocks](https://erdogant.medium.com) |

-------------------------------------------------------------------------

#### Installation (Pypi)
```bash
pip install d3blocks     # Normal installation
pip install -U d3blocks  # Force update
```

#### Installation (clone)
```bash
git clone https://github.com/d3blocks/d3blocks.git
cd d3blocks
pip install -U .
```  

#### Import d3blocks package
```python
from d3blocks import D3Blocks
# Initialize
d3 = D3Blocks()
```


<hr>

### References
* [bl.ocks](https://bl.ocks.org/)
* [observablehq](https://observablehq.com/top)

### Contributors
Setting up and maintaining D3blocks has been possible thanks to users and contributors. Thanks to:

<p align="left">
  <a href="https://github.com/d3blocks/d3blocks/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=d3blocks/d3blocks" />
  </a>
</p>

### Maintainer
* Erdogan Taskesen, github: [erdogant](https://github.com/erdogant)
* Contributions are welcome.
* Yes! This library is entirely **free** but it runs on coffee! :) Feel free to support with a <a href="https://erdogant.github.io/donate/?currency=USD&amount=5">Coffee</a>.

[![Buy me a coffee](https://img.buymeacoffee.com/button-api/?text=Buy+me+a+coffee&emoji=&slug=erdogant&button_colour=FFDD00&font_colour=000000&font_family=Cookie&outline_colour=000000&coffee_colour=ffffff)](https://www.buymeacoffee.com/erdogant)

